diff --git a/gcc/analyzer/hardcoded-state-machine-taint.cc b/gcc/analyzer/hardcoded-state-machine-taint.cc
index 682726c..d6c2d6c 100644
--- a/gcc/analyzer/hardcoded-state-machine-taint.cc
+++ b/gcc/analyzer/hardcoded-state-machine-taint.cc
@@ -40,16 +40,23 @@ static const bool DEBUG = false;
 
 ////////////////////////////////////////////////////////////////////////////
 
-class tainted_array_index : public pending_diagnostic
+class tainted_array_index : public pending_diagnostic_subclass<tainted_array_index>
 {
 public:
   tainted_array_index (tree arg) : m_arg (arg) {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "tainted_array_index"; }
+
+  bool operator== (const tainted_array_index &other) const
+  {
+    return m_arg == other.m_arg;
+  }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     metadata m;
     m.add_cwe (129);
-    warning_at (rich_loc, m,
+    warning_at (rich_loc, m, OPT_Wanalyzer_tainted_array_index,
 		"use of tainted value %qE in array lookup without bounds checking",
 		m_arg);
   }
@@ -71,7 +78,7 @@ taint_state_machine::taint_state_machine (logger *logger)
   m_stop = add_state ("stop");
 }
 
-void
+bool
 taint_state_machine::on_stmt (sm_context *sm_ctxt,
 			       const supernode *node,
 			       const gimple *stmt) const
@@ -93,6 +100,7 @@ taint_state_machine::on_stmt (sm_context *sm_ctxt,
 	  if (TREE_CODE (arg) == ADDR_EXPR)
 	    sm_ctxt->on_transition (node, stmt, TREE_OPERAND (arg, 0),
 				    m_start, m_tainted);
+	  return true;
 	}
     }
 
@@ -155,6 +163,7 @@ taint_state_machine::on_stmt (sm_context *sm_ctxt,
 	}
     }
 #endif
+  return false;
 }
 
 /* FIXME.  */
@@ -214,3 +223,9 @@ taint_state_machine::on_leak (sm_context *sm_ctxt,
 {
   /* Empty.  */
 }
+
+bool
+taint_state_machine::can_purge_p (state_t s) const
+{
+  return true;
+}
diff --git a/gcc/analyzer/hardcoded-state-machine.h b/gcc/analyzer/hardcoded-state-machine.h
index 274c968..ff9065f 100644
--- a/gcc/analyzer/hardcoded-state-machine.h
+++ b/gcc/analyzer/hardcoded-state-machine.h
@@ -54,7 +54,8 @@ public:
 
   const char *get_state_name (state_t s) const;
 
-  virtual void on_stmt (sm_context *sm_ctxt,
+  /* Return true if STMT is a function call recognized by this sm.  */
+  virtual bool on_stmt (sm_context *sm_ctxt,
 			const supernode *node,
 			const gimple *stmt) const = 0;
 
@@ -68,6 +69,11 @@ public:
 			tree var,
 			state_machine::state_t state) const = 0;
 
+  /* Return true if it safe to discard the given state (to help
+     when simplifying state objects).
+     States that need leak detection should return false.  */
+  virtual bool can_purge_p (state_t s) const = 0;
+
 protected:
   state_t add_state (const char *name);
 
@@ -126,8 +132,28 @@ class pending_diagnostic
 {
  public:
   virtual ~pending_diagnostic () {}
+
+  /* Hand-coded RTTI: get an ID for the subclass.  */
+  virtual const char *get_kind () const = 0;
+
   virtual void emit (rich_location *) = 0;
 
+  /* Compare for equality with OTHER, which might be of a different
+     subclass.  */
+
+  bool equal_p (const pending_diagnostic &other)
+  {
+    /* Check for pointer equality on the IDs from get_kind.  */
+    if (get_kind () != other.get_kind ())
+      return false;
+    /* Call vfunc now we know they have the same ID: */
+    return subclass_equal_p (other);
+  }
+  /* A vfunc for testing for equality, where we've already
+     checked they have the same ID.  See pending_diagnostic_subclass
+     below for a convenience subclass for implementing this.  */
+  virtual bool subclass_equal_p (const pending_diagnostic &other) const = 0;
+
   /* For greatest precision-of-wording, give the pending diagnostic
      a chance to describe critical state changes in terms of the
      diagnostic.
@@ -170,6 +196,23 @@ class pending_diagnostic
     ATTRIBUTE_GCC_DIAG(1,2);
 };
 
+/* Use of the curiously-recurring template pattern, to implement
+   subclass_equal_p by casting and calling the operator==
+   This assumes that BASE_OTHER has already been checked to have
+   been of the same subclass.  */
+
+template <class Subclass>
+class pending_diagnostic_subclass : public pending_diagnostic
+{
+ public:
+  bool subclass_equal_p (const pending_diagnostic &base_other) const
+    FINAL OVERRIDE
+  {
+    const Subclass &other = (const Subclass &)base_other;
+    return *(const Subclass*)this == other;
+  }
+};
+
 #if 0
 /* A thing for state machines to pass to the engine to create
    pending_diagnostic instances (so that we can filter without having 
@@ -226,7 +269,7 @@ class malloc_state_machine : public state_machine
 public:
   malloc_state_machine (logger *logger);
 
-  void on_stmt (sm_context *sm_ctxt,
+  bool on_stmt (sm_context *sm_ctxt,
 		const supernode *node,
 		const gimple *stmt) const FINAL OVERRIDE;
 
@@ -239,6 +282,7 @@ public:
 		const gimple *stmt,
 		tree var,
 		state_machine::state_t state) const FINAL OVERRIDE;
+  bool can_purge_p (state_t s) const FINAL OVERRIDE;
 
   state_t m_start;
   state_t m_unchecked;
@@ -260,7 +304,7 @@ class fileptr_state_machine : public state_machine
 public:
   fileptr_state_machine (logger *logger);
 
-  void on_stmt (sm_context *sm_ctxt,
+  bool on_stmt (sm_context *sm_ctxt,
 		const supernode *node,
 		const gimple *stmt) const FINAL OVERRIDE;
 
@@ -273,6 +317,7 @@ public:
 		const gimple *stmt,
 		tree var,
 		state_machine::state_t state) const FINAL OVERRIDE;
+  bool can_purge_p (state_t s) const FINAL OVERRIDE;
 
 private:
   state_t m_start;
@@ -293,7 +338,7 @@ class taint_state_machine : public state_machine
 public:
   taint_state_machine (logger *logger);
 
-  void on_stmt (sm_context *sm_ctxt,
+  bool on_stmt (sm_context *sm_ctxt,
 		const supernode *node,
 		const gimple *stmt) const FINAL OVERRIDE;
 
@@ -306,6 +351,7 @@ public:
 		const gimple *stmt,
 		tree var,
 		state_machine::state_t state) const FINAL OVERRIDE;
+  bool can_purge_p (state_t s) const FINAL OVERRIDE;
 
 private:
   state_t m_start;
@@ -325,7 +371,7 @@ class sensitive_state_machine : public state_machine
 public:
   sensitive_state_machine (logger *logger);
 
-  void on_stmt (sm_context *sm_ctxt,
+  bool on_stmt (sm_context *sm_ctxt,
 		const supernode *node,
 		const gimple *stmt) const FINAL OVERRIDE;
 
@@ -338,12 +384,13 @@ public:
 		const gimple *stmt,
 		tree var,
 		state_machine::state_t state) const FINAL OVERRIDE;
+  bool can_purge_p (state_t s) const FINAL OVERRIDE;
 
 private:
-  void warn_for_any_leakage (sm_context *sm_ctxt,
-			     const supernode *node,
-			     const gimple *stmt,
-			     tree arg) const;
+  void warn_for_any_exposure (sm_context *sm_ctxt,
+			      const supernode *node,
+			      const gimple *stmt,
+			      tree arg) const;
 
   state_t m_start;
   state_t m_sensitive;
@@ -360,7 +407,7 @@ class pattern_test_state_machine : public state_machine
 public:
   pattern_test_state_machine (logger *logger);
 
-  void on_stmt (sm_context *sm_ctxt,
+  bool on_stmt (sm_context *sm_ctxt,
 		const supernode *node,
 		const gimple *stmt) const FINAL OVERRIDE;
 
@@ -373,6 +420,7 @@ public:
 		const gimple *stmt,
 		tree var,
 		state_machine::state_t state) const FINAL OVERRIDE;
+  bool can_purge_p (state_t s) const FINAL OVERRIDE;
 
 private:
   state_t m_start;
diff --git a/gcc/analyzer/impl-3.cc b/gcc/analyzer/impl-3.cc
index 30b3240..1bfaca4 100644
--- a/gcc/analyzer/impl-3.cc
+++ b/gcc/analyzer/impl-3.cc
@@ -41,7 +41,9 @@
 #include "fold-const.h"
 #include "tristate.h"
 #include "selftest.h"
-#include "constraints.h"
+#include "path-state.h"
+
+using namespace psn;
 
 namespace impl_3 {
 
@@ -87,7 +89,7 @@ class engine;
 
 /* FIXME.  */
 
-class ec3_state : public extra_ec_state
+class ec3_state : public psn::extra_ec_state
 {
  public:
   ec3_state (const state_machine &sm,
@@ -645,10 +647,10 @@ public:
 		  state_machine::state_t baseline_state,
 		  state_machine::state_t new_state);
 
-  equiv_class &get_ec (tree expr)
+  psn::equiv_class &get_ec (tree expr)
   {
     path_var pv (expr, get_stack_depth ());
-    equiv_class_id ec_id = m_ps.get_or_add_equiv_class (pv);
+    psn::equiv_class_id ec_id = m_ps.get_or_add_equiv_class (pv);
     return ec_id.get_obj (m_ps);
   }
 
@@ -781,7 +783,7 @@ public:
   void reset_baseline_states ()
   {
     int i;
-    equiv_class *ec;
+    psn::equiv_class *ec;
     FOR_EACH_VEC_ELT (m_path->m_ps.m_equiv_classes, i, ec)
       {
 	ec3_state *extra_state = (ec3_state *)ec->m_extra_state;
@@ -1079,7 +1081,7 @@ checker3_path::add_link (const superedge *edge, const supernode *node)
 state_machine::state_t
 checker3_path::get_baseline_state (tree expr)
 {
-  equiv_class &ec = get_ec (expr);
+  psn::equiv_class &ec = get_ec (expr);
   ec3_state *extra_state = (ec3_state *)ec.m_extra_state;
   if (extra_state)
     return extra_state->m_baseline_state;
@@ -1092,7 +1094,7 @@ checker3_path::set_state (tree expr,
 			  state_machine::state_t baseline_state,
 			  state_machine::state_t new_state)
 {
-  equiv_class &ec = get_ec (expr);
+  psn::equiv_class &ec = get_ec (expr);
   delete ec.m_extra_state;
   ec.m_extra_state = new ec3_state (get_sm (), baseline_state, new_state);
   if (m_engine->get_logger ())
@@ -1592,7 +1594,6 @@ run_checkers_impl_3 ()
       }
 
 #if 0
-    // TODO: selftest for auto_delete_vec
     auto_delete_vec <state_machine> checkers;
     make_checkers (checkers, the_logger.get_logger ());
 
